#pragma once
#include <string>
#include <iostream>
#include <algorithm>
#include <stdio.h>
#include <tchar.h>
#include "CallObject.h"
#include "Command.h"

class CallCommand : public Command
{
public:
	void Execute(ICOMSessionPtr session, ICOMSessionManagerPtr sessionManager)
	{
		HRESULT res = S_OK;
		ICOMCallCommandPtr callCommand;
		if( FAILED ( res = session->GetCallCommand( &callCommand ) ) )
			{PRINT_ERROR ( "Error gettting interface from Call Command" , res ); return;}

		do
		{
			std::cout << "ICallCommand > ";

			// get user unput
			std::string input;
			std::getline(std::cin, input);
			std::transform(input.begin(), input.end(), input.begin(), ::tolower);
			if( input == "exit") break;

			// execute command
			if	   ( input == "incomingcall")	res = callCommand->IncomingCall( CallObject::GetCallObject(), CallContact::GetContactObject(), RingTone_Unknown, AudioRoute_ToHeadset);
			else if( input == "outgoingcall")	res = callCommand->OutgoingCall( CallObject::GetCallObject(), CallContact::GetContactObject(), AudioRoute_ToHeadset);
			else if( input == "terminatecall")  res = callCommand->TerminateCall( CallObject::GetCallObject() );
			else if( input == "answeredcall")	res = callCommand->AnsweredCall( CallObject::GetCallObject() );
			else if( input == "holdcall")		res = callCommand->HoldCall( CallObject::GetCallObject() );
			else if( input == "resumecall")		res = callCommand->ResumeCall( CallObject::GetCallObject() );
			else if( input == "insertcall")		res = callCommand->InsertCall( CallObject::GetCallObject() , CallContact::GetContactObject());
			else if( input == "mutecall")		res = callCommand->MuteCall( CallObject::GetCallObject(), VARIANT_TRUE);
			else if( input == "unmutecall")		res = callCommand->MuteCall( CallObject::GetCallObject(), VARIANT_FALSE);
			else if( input == "audiospeaker")	res = callCommand->SetAudioRoute( CallObject::GetCallObject() , AudioRoute_ToSpeaker);
			else if( input == "audioheadset")	res = callCommand->SetAudioRoute( CallObject::GetCallObject() , AudioRoute_ToHeadset);
			else if( input == "makecall")		res = callCommand->MakeCall( CallContact::GetContactObject() );
			else if( input == "setconferenceid")res = callCommand->SetConferenceId( CallObject::GetCallObject() );
			else if( input == "help")
			{
				std::cout << "incomingcall:        callCommand->IncomingCall" << std::endl;
				std::cout << "outgoingcall:        callCommand->OutgoingCall" << std::endl;
				std::cout << "terminatecall:       callCommand->TerminateCall" << std::endl;
				std::cout << "answeredcall:        callCommand->AnsweredCall" << std::endl;
				std::cout << "holdcall:            callCommand->HoldCall" << std::endl;
				std::cout << "resumecall:          callCommand->ResumeCall" << std::endl;
				std::cout << "insertcall:          callCommand->InsertCall" << std::endl;
				std::cout << "mutecall:            callCommand->MuteCall" << std::endl;
				std::cout << "ummutecall:          callCommand->MuteCall" << std::endl;
				std::cout << "audiospeaker:        callCommand->SetAudioRoute" << std::endl;
				std::cout << "audioheadset:        callCommand->SetAudioRoute" << std::endl;
				std::cout << "makecall:            callCommand->MakeCall" << std::endl;
				std::cout << "setconferenceid:     callCommand->SetConferenceId" << std::endl;
				continue;
			}
			else { std::cout << "type help for list of commands" << std::endl; continue; }
			// Print command execution status
			PRINT_STATUS( res );

		} while ( true );


		delete this;
	}
};