#pragma once

std::string EnumToString(eCallState val)
{
	std::string str;
	switch (val)
	{
	
	case CALL_STATE_UNKNOWN: str = "CALL_STATE_UNKNOWN  "; break;
	case CALL_STATE_ACCEPT_CALL: str = "CALL_STATE_ACCEPT_CALL  "; break;
	case CALL_STATE_TERMINATE_CALL: str = "  CALL_STATE_TERMINATE_CALL"; break;
	case CALL_STATE_HOLD_CALL: str = "CALL_STATE_HOLD_CALL  "; break;
	case CALL_STATE_RESUME_CALL: str = " CALL_STATE_RESUME_CALL "; break;
	case CALL_STATE_FLASH: str = "CALL_STATE_FLASH  "; break;
	case CALL_STATE_CALL_IN_PROGRESS: str = "CALL_STATE_CALL_IN_PROGRESS  "; break;
	case CALL_STATE_CALL_RINGING: str = "CALL_STATE_CALL_RINGING  "; break;
	case CALL_STATE_CALL_ENDED: str = "CALL_STATE_CALL_ENDED  "; break;
	case CALL_STATE_TRANSFER_TO_HEADSET: str = " CALL_STATE_TRANSFER_TO_HEADSET "; break;
	case CALL_STATE_TRANSFER_TO_SPEAKER: str = "CALL_STATE_TRANSFER_TO_SPEAKER  "; break;
	case CALL_STATE_MUTEON: str = "CALL_STATE_MUTEON  "; break;
	case CALL_STATE_MUTEOFF: str = "CALL_STATE_MUTEOFF  "; break;
	case CALL_STATE_MOBILE_CALL_RINGING: str = " CALL_STATE_MOBILE_CALL_RINGING "; break;
	case CALL_STATE_MOBILE_CALL_IN_PROGRESS: str = "CALL_STATE_MOBILE_CALL_IN_PROGRESS  "; break;
	case CALL_STATE_MOBILE_CALL_ENDED: str = "  CALL_STATE_MOBILE_CALL_ENDED"; break;
	case CALL_STATE_DON: str = " CALL_STATE_DON "; break;
	case CALL_STATE_DOFF: str = "CALL_STATE_DOFF  "; break;
	case CALL_STATE_CALL_IDLE: str = "  CALL_STATE_CALL_IDLE"; break;
	case CALL_STATE_PLAY: str = "CALL_STATE_PLAY  "; break;
	case CALL_STATE_PAUSE: str = "  CALL_STATE_PAUSE"; break;
	case CALL_STATE_STOP: str = "CALL_STATE_STOP  "; break;
	case CALL_STATE_DTMF_KEY: str = " CALL_STATE_DTMF_KEY "; break;
	case CALL_STATE_REJECT_CALL: str = "CALL_STATE_REJECT_CALL  "; break;
	case CALL_STATE_MAKE_CALL: str = " CALL_STATE_MAKE_CALL "; break; // Information only.  
	case CALL_STATE_HOOK: str = "  CALL_STATE_HOOK"; break;
	case CALL_STATE_HOOK_IDLE: str = " CALL_STATE_HOOK_IDLE "; break;
	case CALL_STATE_HOOK_DOCKED: str = "  CALL_STATE_HOOK_DOCKED"; break;
	case CALL_STATE_HOOK_UNDOCKED: str = " CALL_STATE_HOOK_UNDOCKED"; break;
	case CALL_STATE_BASE_EVENT: str = "CALL_STATE_BASE_EVENT  "; break;
	case CALL_STATE_CALL_ANSWERED_AND_ENDED: str = "CALL_STATE_CALL_ANSWERED_AND_ENDED  "; break;
	case CALL_STATE_CALL_UNANSWERED_AND_ENDED: str = "CALL_STATE_CALL_UNANSWERED_AND_ENDED  "; break;
	default:return "CALL_STATE_UNKNOWN";
	};
	return str;
}


std::string EnumToString(eDeviceState val)
{
	std::string str;
	switch (val)
	{
	case DEV_STATE_ADDED: str = " DEV_STATE_ADDED"; break;

	case DEV_STATE_REMOVED: str = " DEV_STATE_REMOVED"; break;
	default: str = " DEV_STATE_UNKNOWN";
	}
	return str;
}
// create sink for receiving session events
class CallEventSink : public ICallEvents
{
private:
	ISession* m_session;
public:
	CallEventSink() {}
	CallEventSink( ISession* session) : m_session( session ) {	m_session->registerCallback( this ); }
	virtual ~CallEventSink()								 {	m_session->unregisterCallback( this ); }

	virtual bool OnCallStateChanged(CallStateEventArgs const& pcscArgs)	{ 
		std::string state = EnumToString(pcscArgs.callState);
		cout << "OnCallStateChanged Session event " << state.c_str() << endl; return true; }
	virtual bool OnCallRequest(CallRequestEventArgs const& pcscArgs)	{ cout << "OnCallRequest Session event"	     << endl; return true; }
	void operator delete(void *p) { ::operator delete(p); }
};
// create sink for receiving session manager events
class SessionManagerEventSink : public ISessionManagerEvents
{
private: 
	ISessionManager* m_sessionManager;
public:
	SessionManagerEventSink() {}
	SessionManagerEventSink( ISessionManager* sessionManager) : m_sessionManager( sessionManager )	{ m_sessionManager->registerCallback( this ); }
	virtual ~SessionManagerEventSink()																{ m_sessionManager->unregisterCallback( this ); }

	virtual bool OnCallStateChanged(CallStateEventArgs const& cseArgs)		{ 
		std::string state = EnumToString(cseArgs.callState);
		cout << "OnCallStateChanged Session Manager event "	<< state.c_str() << endl; return true; }
    virtual bool OnDeviceStateChanged(DeviceStateEventArgs const& devArgs)	{ 
		std::string state = EnumToString(devArgs.deviceState);
		cout << "OnDeviceStateChanged Session Manager event" << state.c_str() << endl; return true;
	}
	void operator delete(void *p) { ::operator delete(p); }
};