// SpokesNativeSample.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <iostream>
#include <string>
#include <iomanip>

using namespace std;

#include "Spokes3G.h"
#include "cpp\query_cast.h"

#include "EventSink.h"
#include "CallObject.h"



string input;
Call call;
void printDevice(IDevice* device, IHostCommand* hostCommand);

int _tmain(int argc, _TCHAR* argv[])
{
    InitSpokesRuntime();

	// create session manager
	ISessionManager *sessionManager = nullptr;
	if( SM_RESULT_SUCCESS == getSessionManager(&sessionManager) )
	{
		// create session
		ISession* session = nullptr;
		if( SM_RESULT_SUCCESS == sessionManager->registerSession( L"Sample client", &session ) )
		{
			IDevice* activeDevice = nullptr;
			IHostCommand* hostCommand = nullptr;
			if (SM_RESULT_SUCCESS == session->getActiveDevice(&activeDevice))
			{

			//	IHostCommand* hostCommand = nullptr;
				if (DM_RESULT_SUCCESS == activeDevice->getHostCommand(&hostCommand) || hostCommand == nullptr)
					printDevice(activeDevice, hostCommand);
			}
			else {
				cout << "No plantronics device is detected, please attach a device and try again." << endl;
				getline(cin, input);
				ShutDownSpokesRuntime();
				return 0;
			}
			IUserPreference* userPreference = nullptr;
			if( SM_RESULT_SUCCESS == sessionManager->getUserPreference( &userPreference) )
			{
				// set this session as default one for receiving CallRequest events
				int32_t pluginId;
				session->getPluginId(&pluginId);
				userPreference->setDefaultSoftphone( pluginId );
			}
	//		ISessionManagerEvents* sessionManagerCallback; 
//			sessionManager->registerCallback(sessionManagerCallback);
			// get call command
			ICallCommand* callCommand = nullptr;
			if( SM_RESULT_SUCCESS == session->getCallCommand( &callCommand ) )
			{
				// sink to all call events
				unique_ptr<CallEventSink> callEvents( new CallEventSink(session) );
				unique_ptr<SessionManagerEventSink> sessionManagerEvents( new SessionManagerEventSink( sessionManager ) );
				
				// enter in command loop
				do
				{
					cout << " > ";
					getline(cin, input);
					// call commands
					if( input == "incomingcall" )		  callCommand->incomingCall(  GetCall(call), GetContact(), RING_TONE_UNKNOWN, GetAudioRoute() );
					else if( input == "outgoingcall")	  callCommand->outgoingCall(  GetCall(call), GetContact(), GetAudioRoute() );
					else if( input == "terminatecall")    callCommand->terminateCall( GetCall(call) );
					else if( input == "answeredcall")	  callCommand->answeredCall(  GetCall(call) );
					else if( input == "holdCall")		  callCommand->holdCall(	  GetCall(call) );
					else if( input == "resumecall")		  callCommand->resumeCall(	  GetCall(call) );
					else if( input == "insertcall")		  callCommand->insertCall(	  GetCall(call) , GetContact());
					else if( input == "mutecallon")		  callCommand->muteCall( true );
					else if( input == "mutecalloff")	  callCommand->muteCall( false );
					else if( input == "setaudioroutehs")  callCommand->setAudioRoute(	GetCall(call), AUDIO_ROUTE_TO_HEADSET );
					else if( input == "setaudioroutesp")  callCommand->setAudioRoute(	GetCall(call), AUDIO_ROUTE_TO_SPEAKER );
					else if( input == "makecall")		  callCommand->makeCall( GetContact() );
					else if( input == "setconferenceid")  callCommand->setConferenceId( GetCall(call) );
					else if (input == "device")
						printDevice(activeDevice, hostCommand);
					else if (input == "help")
					{
						std::cout << "incomingcall:        callCommand->IncomingCall" << std::endl;
						std::cout << "outgoingcall:        callCommand->OutgoingCall" << std::endl;
						std::cout << "terminatecall:       callCommand->TerminateCall" << std::endl;
						std::cout << "answeredcall:        callCommand->AnsweredCall" << std::endl;
						std::cout << "holdcall:            callCommand->HoldCall" << std::endl;
						std::cout << "resumecall:          callCommand->ResumeCall" << std::endl;
						std::cout << "insertcall:          callCommand->InsertCall" << std::endl;
						std::cout << "mutecall:            callCommand->MuteCall" << std::endl;
						std::cout << "ummutecall:          callCommand->MuteCall" << std::endl;
						std::cout << "audiospeaker:        callCommand->SetAudioRoute" << std::endl;
						std::cout << "audioheadset:        callCommand->SetAudioRoute" << std::endl;
						std::cout << "makecall:            callCommand->MakeCall" << std::endl;
						std::cout << "setconferenceid:     callCommand->SetConferenceId" << std::endl;
						std::cout << "device:              printDevice(activeDevice, hostCommand)" << std::endl;
						continue;
					}
				//	else { std::cout << "type help for list of commands" << std::endl; continue; }
					// Print com
					
					/*
									}
									while (input != "exit" );
									input = "";
					//			}*/
							}
							while (input != "exit" );
							input = "";
							activeDevice->Release();
						}
					}


			sessionManager->unregisterSession( session );
			session->Release();
		}
//p		sessionManager->Release();
	//}
	std::cout << "Closing application";
	getline(cin, input);

    ShutDownSpokesRuntime();

	return 0;
}

void printDevice( IDevice* device, IHostCommand* hostCommand )
{
	wchar_t buffer1[1024], buffer2[1024], buffer3[1024], buffer4[1024], buffer5[1024];
	device->getDevicePath( buffer1, 1024 );
	device->getInternalName( buffer2, 1024 );
	device->getProductName( buffer3, 1024 );
	device->getManufacturerName( buffer4, 1024 );
	device->getSerialNumber( buffer5, 1024 );
	int32_t pid = device->getProductID();

	wcout << L"*********************************" << endl;
	wcout << L"* PID:             0x" << setfill(L'0') << setw(4) << hex << pid << endl;
	wcout << L"* VID:             0x" << hex << device->getVendorID() << endl;
	wcout << L"* Path:            "	  << buffer1 << endl;
	wcout << L"* Name:            "   << buffer2 << endl;
	wcout << L"* Product:         "   << buffer3 << endl;
	wcout << L"* Manufacturer:    "	  << buffer4 << endl;
	wcout << L"* Serial NO HID:   "	  << buffer5 << endl;
	cout << "*********************************" << endl;

}

