﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Interop.Plantronics;
using SpokesSDKCOMNETSample.Commands;
using System.Collections.ObjectModel;

namespace SpokesSDKCOMNETSample
{
    //Abstract class that is meant to be inherited by concrete commands.
    //Handles any unexpected exception during command execution
    abstract class Command : ICommand
    {
        public void Execute(string command, COMSession session)
        {
            try
            {
                DoExecute(command, session);
            }
            catch (System.Exception)
            {
                Console.WriteLine("Operation not supported");
            }
        }

        abstract public ReadOnlyCollection<string> GetSupportedCommands();

        abstract protected void DoExecute(string command, COMSession session);
    }
}
