﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using SpokesSDKCOMNETSample.Commands;

namespace SpokesSDKCOMNETSample
{
    enum CommandType
    {
        CallCommand,
        DeviceCommand,
        DeviceListenerCommand
    }

    class CommandFactory
    {
        public static ICommand GetCommand(CommandType commandType)
        {
            switch (commandType)
            {
                case CommandType.CallCommand :
                    return new CallCommand();
                case CommandType.DeviceCommand :
                    return new DeviceCommand();
                case CommandType.DeviceListenerCommand :
                    return new DeviceListenerCommand();
                default :
                    return null;
            }
        }
    }
}
