﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Interop.Plantronics;
using System.Collections.ObjectModel;
using System.Runtime.InteropServices;

namespace SpokesSDKCOMNETSample
{
    class DeviceListenerCommand : Command
    {

        private static string MuteOn = "muteon";
        private static string MuteOff = "muteoff";

        private static List<string> supportedCommands = new List<string>(new string[] { MuteOn, MuteOff });

        override protected void DoExecute(string command, COMSession session)
        {
            COMDevice device = session.GetActiveDevice();
            if (device != null)
            {
                COMDeviceListener deviceListener = device.DeviceListener;
                if (deviceListener != null)
                {
                    try
                    {
                        if (command == MuteOn)
                            deviceListener.mute = true;
                        else if (command == MuteOff)
                            deviceListener.mute = false;
                    }
                    catch (COMException ex)
                    {
                        Console.WriteLine("COM exception: " + ex.Message);
                    }
                    catch (Exception ex)
                    {
                        Console.WriteLine("Exception: " + ex.Message);
                    }

                }
                else
                    Console.WriteLine("Could not retrieve device listener object while executing {0} command", command);
            }
            else
                Console.WriteLine("Could not retrieve device object");
        }

        override public ReadOnlyCollection<string> GetSupportedCommands()
        {
            return supportedCommands.AsReadOnly();
        }
    }
}
