﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Interop.Plantronics;
using System.Runtime.InteropServices;

namespace SpokesSDKCOMNETSample
{
    class SessionManagerEventsListener : EventListener
    {
        private ICOMSessionManagerEvents_Event sessionManagerEvents = null;

        public SessionManagerEventsListener(ICOMSessionManager sessionManager)
        {
            sessionManagerEvents = sessionManager as ICOMSessionManagerEvents_Event;
            if (sessionManagerEvents != null)
            {
                sessionManagerEvents.onCallStateChanged += onCallStateChanged;
                sessionManagerEvents.onDeviceStateChanged += onDeviceStateChanged;

                Console.WriteLine("Successfully hooked to Session Manager events");
            }
            else
                Console.WriteLine("Unable to hook to Session Manager events");
        }

        ~SessionManagerEventsListener()
        {
            if (sessionManagerEvents != null)
            {
                sessionManagerEvents.onCallStateChanged -= onCallStateChanged;
                sessionManagerEvents.onDeviceStateChanged -= onDeviceStateChanged;

                Marshal.ReleaseComObject(sessionManagerEvents);
                sessionManagerEvents = null;
            }
        }

        private void onCallStateChanged(COMCallEventArgs callEventArgs)
        {
            WriteOutput("Session Manager event: call state changed: " + callEventArgs.CallState.ToString());
        }

        private void onDeviceStateChanged(COMStateDeviceEventArgs deviceEventArgs)
        {
            WriteOutput("Session Manager event: device state changed: " + deviceEventArgs.DeviceState.ToString());
        }
    }
}
